      //if(forceBalanceEnabled && !balanceReached)
      {
         static vector accelMass           = vector(0,0,0);
         static vector thetaAccel          = vector(0,0,0);

         static vector forceStatic         = vector(0,0,0);
         static vector mometStatic         = vector(0,0,0);

         static vector totPressureForce    = vector(0,0,0);
         static vector totPressureMomet    = vector(0,0,0);

         static vector totViscousForce     = vector(0,0,0);
         static vector totViscousMomet     = vector(0,0,0);

         static vector calcVelocity   = vector(0,0,0);
         static vector calcDistance   = vector(0,0,0);
         static vector thetaVelty     = vector(0,0,0);
         static vector thetaDiste     = vector(0,0,0);

	 static vector springForce = vector(0,0,0);
	 static vector   springAccl =vector(0,0,0); 
	 static vector    springVel = vector(0,0,0);
	 static vector   springDist =vector(0,0,0); 


         //if((runTime.timeOutputValue() - previousCalcTime_F) >= deltaT.value())
         {	      
	   //Info << "ettta " <<endl;

	   
            totPressureForce          = vector(0,0,0);
            totPressureMomet          = vector(0,0,0);

            totViscousForce           = vector(0,0,0);
            totViscousMomet           = vector(0,0,0);

	    vector gravityMomet = vector::zero;

	    sphericalTensor sph1 = sphericalTensor::one;

	    vector gravityForce = vector::zero;

            vector patchPressForce    = vector(0,0,0);
            vector patchPressMomet    = vector(0,0,0);
            	    
            // Calculate the real delta T
            scalar realDeltaT = runTime.timeOutputValue() - previousCalcTime_F;

            // Update the absolute time
            previousCalcTime_F = runTime.timeOutputValue();
	    
	    
	    //tensor of inertia
	    
	    forAll(motionPatches,mPI1)
	      {
		label patchIndex = mesh.boundaryMesh().findPatchID(motionPatches[mPI1]);    
		//bodyInertia = sum((mesh.Cf().boundaryField()[patchIndex] - CgCenter) & (mesh.Cf().boundaryField()[patchIndex] - CgCenter) );
	      }
	    
	    

               forAll(motionPatches,fPI) 
               {
		 label forcePatchID = mesh.boundaryMesh().findPatchID(motionPatches[fPI]);
//summing up the pressure on the patch and the area with normal vectors
		 scalarField Ptotal      = pos(p.boundaryField()[forcePatchID])*(p.boundaryField()[forcePatchID]);
//summing over the same and then crossprduct with the translated positions of the points on the patch	 
		 patchPressForce  = gSum( p.boundaryField()[forcePatchID]
					  * mesh.Sf().boundaryField()[forcePatchID]
					  );//* mediumRho.value() // needed?
		 
		 patchPressMomet  = gSum( p.boundaryField()[forcePatchID]
					  * mesh.Sf().boundaryField()[forcePatchID]
					  ^(mesh.Cf().boundaryField()[forcePatchID] - CgCenter)
					  );//* mediumRho.value() //needed?
		 
                  totPressureForce += patchPressForce;
                  totPressureMomet -= patchPressMomet;
		  Info << " totPressureForce  " << totPressureForce  << endl;
		  Info << " totPressureMomet  " << totPressureMomet  << endl;
               
	       }
	      

	      //kinematic viscosity field
               volScalarField muf = twoPhaseProperties.mu();

               forAll(motionPatches,fPI)
               {
                  label forcePatchID = mesh.boundaryMesh().findPatchID(motionPatches[fPI]);
   //kinematic viscosity around the patch
                  scalarField mu1 = muf.boundaryField()[forcePatchID];
// for forces, velocity * area * kinematic viscosity.
                  vector patchViscousForce = gSum((- U.boundaryField()[forcePatchID].snGrad()
                                                   * mesh.magSf().boundaryField()[forcePatchID])
                                                   * mu1 
                                                 );
//moments
                  vector patchViscousMomet = gSum((- U.boundaryField()[forcePatchID].snGrad()
                                                   * mesh.magSf().boundaryField()[forcePatchID])
                                                   * mu1
                                                  ^(mesh.Cf().boundaryField()[forcePatchID] - CgCenter)
                                                 );
                  totViscousForce += patchViscousForce;
                  totViscousMomet -= patchViscousMomet;		 
		  Info << " totviscForce  " << totViscousForce  << endl;
		  Info << " totviscMomet  " << totViscousMomet  << endl;
               }
	      

	    gravityForce = bodyMass.value()*(gravityAccel.value() * gVector); 
	    //gravityMomet = gravityForce ^ CgCenter;

	    Info <<"gforce  " <<gravityForce << endl;
	    //Info <<"gMom  " << gravityMomet << endl;
	    //Info <<"  " << << endl;
	    scalar mint(0.01);
            
	    forceStatic = totPressureForce
	      + totViscousForce + gravityForce;

	    
	    Info <<"  forceStatic " << forceStatic << endl;
	    
            mometStatic = totPressureMomet
	      + totViscousMomet;

	    
	    Info <<" mometStatic  " << mometStatic << endl;



//from the forces the acceleration is calculated.
accelMass  = (forceStatic)/bodyMass.value();	
            //...by division with mass for forces and inertia for moments
thetaAccel = (mometStatic)/bodyInertia.value();

	    /*
To keep the patch from moving too much in the begining of the 
simulation a max-value for the acceleration 
is enforced. This can be specifie by the user.
*/
	    if(accelLim.value() != 0.0)
	      {	   
		//Info <<",,,,,,,,,,,,,,,,,,,,,,,,  " << endl;
		
		thetaAccel = vector (min((thetaAccel & dirVector1),accelLim.value()),
				    min((thetaAccel & dirVector2),accelLim.value()),
				    min((thetaAccel & dirVector3),accelLim.value()));
		thetaAccel = vector(max((thetaAccel & dirVector1),(-1.0)*accelLim.value()),
				    max((thetaAccel & dirVector2),(-1.0)*accelLim.value()),
				    max((thetaAccel & dirVector3),(-1.0)*accelLim.value()));

		accelMass  = vector(min((accelMass & dirVector1),accelLim.value()),
				    min((accelMass & dirVector2),accelLim.value()),
				    min((accelMass & dirVector3),accelLim.value()));
		accelMass  = vector(max((accelMass & dirVector1),(-1.0)*accelLim.value()),
				    max((accelMass & dirVector2),(-1.0)*accelLim.value()),
				    max((accelMass & dirVector3),(-1.0)*accelLim.value()));
	      }

//calculate the accumulated velocity and accumulated displacement and 
// the accumulated rotation speed and accumulated angle
            thetaVelty   = thetaVelty + thetaAccel   * realDeltaT;
            thetaDiste   = thetaDiste + thetaVelty   * realDeltaT;
            calcVelocity = calcVelocity + accelMass    * realDeltaT;
            calcDistance = calcDistance + calcVelocity * realDeltaT;



	    Info <<"calcdist " << calcDistance << endl;
	    Info <<"thetaDiste.z() " << thetaDiste.z() << endl;
	    Info << "calcdist" << calcDistance << endl;
            vector calcLocalVelocity = accelMass * realDeltaT;
            vector calcLocalDistance = calcLocalVelocity * realDeltaT;
            vector thetaLocalVelty = thetaAccel * realDeltaT;

//boat

/*
If the motion should be restricted the solver has to be recompiled. 
in the R object just below the thetaDiste.* can be changed to 0 if
there should be not rotation along that axis. 

For translation, if the translations should be restricted, change
calcDistance.* to 0 to not allow for translation in this direction.

*/
//assign the quaternion the accumulated angles that have been calculated 
	quaternion R(thetaDiste.x(), thetaDiste.y(), thetaDiste.z());
	     //assign the septernion the accumulated distances at each timestep  
	septernion TR(vector(calcDistance.x(), calcDistance.y(), calcDistance.z()));
        

        CgCenter = vector(forceFoamDict.lookup("CgCenter"));
	
        Info << "CgCenter " << CgCenter <<endl;
	//	CgCenter = TR.transform(CgCenter);
	Info << "CgCenter " << CgCenter <<endl;
	    forAll(motionPatches,mPI)
	      {	 		
label patchIndex = mesh.boundaryMesh().findPatchID(motionPatches[mPI]);
//save in temporary fields
pointField tempPointE = tempPoint;
vectorField tempCellE = tempCell;
//move relative center of gravity
tempCellE -= CgCenter;
tempPointE -= CgCenter;
//rotate by scalar product with rotation tensor 
tempCellr = tempCellE & R.R();
tempPointr = tempPointE & R.R(); 
//move back
tempCellr += CgCenter;
tempPointr += CgCenter;
//translate
tempPointd = tempPointr + TR.t();
tempCelld = tempCellr + TR.t();
//subtract from original position to get displacement
tempPointd -= tempPoint;
tempCelld -= tempCell;

//use == to assign the displacement
pointDisplacement.boundaryField()[patchIndex] == tempPointd;

cellDisplacement.boundaryField()[patchIndex] == tempCelld;
	      }

	CgCenter = TR.transform(CgCenter);
	    Info << "CgCenter " << CgCenter <<endl;	    
}
}
